#pragma once

#ifndef __D12GRAPH__
#define __D12GRAPH__

#include <Windows.h>
#include <VersionHelpers.h>

#include <d2d1_3.h>
#include <dwrite.h>
#include <d3d11on12.h>
#include <d3d12.h>
#include <dxgi1_6.h>
#include <D3Dcompiler.h>
#include <DirectXMath.h>

#include <wrl.h>

#include <Wincodec.h>

#include <vector>

#include "Config.h"

const short GPU_PRIMARY{ 0 };

struct D12Interface {
	Microsoft::WRL::ComPtr<IDXGIAdapter1> Adapter{ nullptr };
	bool Hardware{};
	std::wstring GPU_Name{};
	D3D_FEATURE_LEVEL D3D_Level{};
	std::wstring strLevel{};
};

struct Screen {
	int Width{};
	int Height{};
	DXGI_OUTPUT_DESC desc{};
	int DPI{};
	int OutputNum{};
	int ModeNum{};
};

class D12Graphics {
private:
	std::vector<D12Interface> InterfaceList;
	short GPU_Num{ GPU_PRIMARY };

	std::vector<Screen> CurrentOutput{};

public:
	D12Graphics();
	~D12Graphics();

	bool CheckVersionSupport();
	bool CheckSupport();

	bool GetResolutions(Config &);

	void AdapterList(D12Interface&);

	size_t GetInterfacesNum() { return InterfaceList.size(); }

	void SetInterface(short number) { GPU_Num = number; }
};

#endif __D12GRAPH__