#include <Windows.h>

#include <string>
#include <fstream>

#include "Logger.h"

std::fstream filehandle{};

HRESULT Logger(std::string func, std::string file, int line, HRESULT hr) {
	if ((hr != S_OK) && (hr != S_FALSE)) {
		std::string code = "logging: Func: " + func + " in file: " + file;
		code += " on line " + std::to_string(line);

		LPSTR pText;
		FormatMessageA(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL, hr, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPSTR)&pText, 0, NULL);

		Log_Write(code);
		Log_Write(pText);

		return hr;
	}
	else if (hr == 2) {
		std::string code = "logging: Func: " + func + " in file: " + file;
		code += " on line " + std::to_string(line);

		Log_Write(code);
	}

	return 0;
}

bool Log_Open(std::string filename) {
	if (!filehandle.is_open()) {
		filehandle.open(filename.c_str(), std::ios::out | std::ios::trunc);

		_wsetlocale(LC_ALL, L"");
		std::ios_base::sync_with_stdio(false);
		filehandle.imbue(std::locale(""));
		
		return true;
	}

	return false;
}

void Log_Write(std::string text) {
	if (filehandle.is_open()) {
		filehandle << text << "\n";
	}
}

bool Log_Close() {
	if(filehandle.is_open()) {
		filehandle.close();

		return true;
	}

	return false;
}